{-# LANGUAGE TypeApplications #-}


-- | Copyright  : Will Thompson and Iñaki García Etxebarria
-- License    : LGPL-2.1
-- Maintainer : Iñaki García Etxebarria
-- 
-- A t'GI.GObject.Objects.ParamSpec.ParamSpec' derived structure that contains the meta data for pointer properties.

#if (MIN_VERSION_haskell_gi_overloading(1,0,0) && !defined(__HADDOCK_VERSION__))
#define ENABLE_OVERLOADING
#endif

module GI.GObject.Objects.ParamSpecPointer
    ( 

-- * Exported types
    ParamSpecPointer(..)                    ,
    IsParamSpecPointer                      ,
    toParamSpecPointer                      ,


 -- * Methods
-- | 
-- 
--  === __Click to display all available methods, including inherited ones__
-- ==== Methods
-- [sink]("GI.GObject.Objects.ParamSpec#g:method:sink"), [stealQdata]("GI.GObject.Objects.ParamSpec#g:method:stealQdata").
-- 
-- ==== Getters
-- [getBlurb]("GI.GObject.Objects.ParamSpec#g:method:getBlurb"), [getDefaultValue]("GI.GObject.Objects.ParamSpec#g:method:getDefaultValue"), [getName]("GI.GObject.Objects.ParamSpec#g:method:getName"), [getNameQuark]("GI.GObject.Objects.ParamSpec#g:method:getNameQuark"), [getNick]("GI.GObject.Objects.ParamSpec#g:method:getNick"), [getQdata]("GI.GObject.Objects.ParamSpec#g:method:getQdata"), [getRedirectTarget]("GI.GObject.Objects.ParamSpec#g:method:getRedirectTarget").
-- 
-- ==== Setters
-- [setQdata]("GI.GObject.Objects.ParamSpec#g:method:setQdata").

#if defined(ENABLE_OVERLOADING)
    ResolveParamSpecPointerMethod           ,
#endif



    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.BasicTypes as B.Types
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GArray as B.GArray
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GHashTable as B.GHT
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.GI.Base.Signals as B.Signals
import qualified Control.Monad.IO.Class as MIO
import qualified Data.Coerce as Coerce
import qualified Data.Text as T
import qualified Data.Kind as DK
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL
import qualified GHC.Records as R
import qualified Data.Word as DW
import qualified Data.Int as DI
import qualified System.Posix.Types as SPT
import qualified Foreign.C.Types as FCT

-- Workaround for https://gitlab.haskell.org/ghc/ghc/-/issues/23392
#if MIN_VERSION_base(4,18,0)
import {-# SOURCE #-} qualified GI.GObject.Objects.ParamSpec as GObject.ParamSpec

#else
import {-# SOURCE #-} qualified GI.GObject.Objects.ParamSpec as GObject.ParamSpec

#endif

-- | Memory-managed wrapper type.
newtype ParamSpecPointer = ParamSpecPointer (SP.ManagedPtr ParamSpecPointer)
    deriving (Eq)

instance SP.ManagedPtrNewtype ParamSpecPointer where
    toManagedPtr (ParamSpecPointer p) = p

foreign import ccall "haskell_gi_pspec_type_init_ParamSpecPointer"
    c_haskell_gi_pspec_type_init_ParamSpecPointer :: IO B.Types.GType

instance B.Types.TypedObject ParamSpecPointer where
    glibType = c_haskell_gi_pspec_type_init_ParamSpecPointer

-- | Type class for types which can be safely cast to `ParamSpecPointer`, for instance with `toParamSpecPointer`.
class (SP.BoxedPtr o, SP.TypedObject o, O.IsDescendantOf ParamSpecPointer o) => IsParamSpecPointer o
instance (SP.BoxedPtr o, SP.TypedObject o, O.IsDescendantOf ParamSpecPointer o) => IsParamSpecPointer o

instance O.HasParentTypes ParamSpecPointer
type instance O.ParentTypes ParamSpecPointer = '[GObject.ParamSpec.ParamSpec]

-- | Cast to `ParamSpecPointer`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toParamSpecPointer :: (MIO.MonadIO m, IsParamSpecPointer o) => o -> m ParamSpecPointer
toParamSpecPointer = MIO.liftIO . B.ManagedPtr.unsafeCastTo ParamSpecPointer

--- XXX Missing getter and/or setter, so no GValue instance could be generated.
#if defined(ENABLE_OVERLOADING)
type family ResolveParamSpecPointerMethod (t :: Symbol) (o :: DK.Type) :: DK.Type where
    ResolveParamSpecPointerMethod "sink" o = GObject.ParamSpec.ParamSpecSinkMethodInfo
    ResolveParamSpecPointerMethod "stealQdata" o = GObject.ParamSpec.ParamSpecStealQdataMethodInfo
    ResolveParamSpecPointerMethod "getBlurb" o = GObject.ParamSpec.ParamSpecGetBlurbMethodInfo
    ResolveParamSpecPointerMethod "getDefaultValue" o = GObject.ParamSpec.ParamSpecGetDefaultValueMethodInfo
    ResolveParamSpecPointerMethod "getName" o = GObject.ParamSpec.ParamSpecGetNameMethodInfo
    ResolveParamSpecPointerMethod "getNameQuark" o = GObject.ParamSpec.ParamSpecGetNameQuarkMethodInfo
    ResolveParamSpecPointerMethod "getNick" o = GObject.ParamSpec.ParamSpecGetNickMethodInfo
    ResolveParamSpecPointerMethod "getQdata" o = GObject.ParamSpec.ParamSpecGetQdataMethodInfo
    ResolveParamSpecPointerMethod "getRedirectTarget" o = GObject.ParamSpec.ParamSpecGetRedirectTargetMethodInfo
    ResolveParamSpecPointerMethod "setQdata" o = GObject.ParamSpec.ParamSpecSetQdataMethodInfo
    ResolveParamSpecPointerMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveParamSpecPointerMethod t ParamSpecPointer, O.OverloadedMethod info ParamSpecPointer p) => OL.IsLabel t (ParamSpecPointer -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod @info
#else
    fromLabel _ = O.overloadedMethod @info
#endif

#if MIN_VERSION_base(4,13,0)
instance (info ~ ResolveParamSpecPointerMethod t ParamSpecPointer, O.OverloadedMethod info ParamSpecPointer p, R.HasField t ParamSpecPointer p) => R.HasField t ParamSpecPointer p where
    getField = O.overloadedMethod @info

#endif

instance (info ~ ResolveParamSpecPointerMethod t ParamSpecPointer, O.OverloadedMethodInfo info ParamSpecPointer) => OL.IsLabel t (O.MethodProxy info ParamSpecPointer) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.MethodProxy
#else
    fromLabel _ = O.MethodProxy
#endif

#endif

-- XXX Wrapping a foreign struct/union with no known destructor or size, leak?
instance BoxedPtr ParamSpecPointer where
    boxedPtrCopy = return
    boxedPtrFree = \_x -> return ()



